#ifndef KEYMAPWIDGET_H
#define KEYMAPWIDGET_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qpainter.h>

#include "simsam.h"
#include "observer.h"
#include "sample.h"
#include "midi.h"

class KeymapWidget : public QWidget, public Observer {

  Q_OBJECT;

 private:

  Sample* sample;
  Instrument* instrument;
  SampleMap* sampleMap;

  QPixmap* barFragments[10];
  QPixmap* buffer;
  QPixmap* background;
  QPixmap* marker;

  int icons[120];
  int xOffset;

  int selectedKey;

 public:

  KeymapWidget(QWidget* parent = NULL, const char* name = NULL);

  void update(Subject* s);
  void subjectDeleted(Subject* s);

  void renderBuffer();
  void buildIconArray();

  // QWidget stuff
  void paintEvent(QPaintEvent *e);
  void mouseMoveEvent(QMouseEvent *e);
  void mousePressEvent(QMouseEvent *e);
  void wheelEvent(QWheelEvent *e);

  public slots:

  void setSample(Sample* s);
  void setInstrument(Instrument* i);

 
};

extern KeymapWidget *keymapWidget;

#endif // KEYMAPWIDGET_H
